/* GCC */
#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

inline unsigned short _hash(unsigned short a, unsigned short b,
                            unsigned short c, unsigned short d)
{return 125*a + 25*b + 5*c + d;}

inline unsigned short inv(unsigned short a)
{return a == 0 ? 1 : 0;}

struct Move
{
    Move(char d, unsigned short n) : dir(d), num(n) {}
    char dir;
    unsigned short num;
};

int main(void)
{
    size_t t, n, n2, right, down, counter;
    unsigned short msk[625] = {}, mask, tmp, need;
    msk[_hash(1, 2, 3, 4)] =
    msk[_hash(3, 1, 2, 4)] =
    msk[_hash(2, 3, 1, 4)] =
    msk[_hash(4, 1, 3, 2)] =
    msk[_hash(2, 4, 3, 1)] =
    msk[_hash(4, 2, 1, 3)] =
    msk[_hash(3, 2, 4, 1)] =
    msk[_hash(1, 4, 2, 3)] =
    msk[_hash(1, 3, 4, 2)] =
    msk[_hash(4, 3, 2, 1)] =
    msk[_hash(3, 4, 1, 2)] =
    msk[_hash(2, 1, 4, 3)] = 1;
    FILE *fin = fopen("square.in", "r");
    FILE *fout = fopen("square.out", "w");
    fscanf(fin, "%u", &t);
    while(t--)
    {
        fscanf(fin, "%u", &n);
        n2 = 1 << n;
        bool bad = false;
        map<unsigned short, unsigned short> m;
        vector<vector<unsigned short> > v(n2, vector<unsigned short>(n2));
        for(size_t i = 0; i < n2; ++i)
            for(size_t j = 0; j < n2; ++j)
                fscanf(fin, "%hu", &v[i][j]);
        for(size_t i = 0; i < n2 && !bad; ++i)
            for(size_t j = 0; j < n2; ++j)
                if(m[v[i][j]] == 0)
                {
                    m[v[i][j]] = m.size()+1;
                    if(m.size() > 4)
                    {
                        bad = true;
                        break;
                    }
                }
        if(bad)
        {
            fprintf(fout, "-1\n");
            continue;
        }
        vector<vector<unsigned short> > hlp(n, vector<unsigned short>(n));
        for(size_t up = 0; up < n; ++up)
            for(size_t left = 0; left < n; ++left)
            {
                right = n2-1-left, down = n2-1-up;
                v[up][left] = m[v[up][left]];
                v[down][left] = m[v[down][left]];
                v[down][right] = m[v[down][right]];
                v[up][right] = m[v[up][right]];
                mask = _hash(v[up][left], v[up][right], v[down][left], v[down][right]);
                hlp[up][left] = msk[mask];
            }
        need = hlp[0][0];
        vector<Move> moves;
        for(size_t i = 1; i < n; ++i)
            if(hlp[i][0] != need)
            {
                for(size_t j = 0; j < n; ++j)
                {
                    hlp[i][j] = inv(hlp[i][j]);
                    swap(v[i][j], v[i][n2-1-j]);
                }
                moves.push_back(Move('+', i+1));
            }
        for(size_t j = 1; j < n; ++j)
        {
            for(size_t i = 1; i < n; ++i)
                if(hlp[i][j] != hlp[0][j])
                {
                    bad = true;
                    break;
                }
            if(bad)
                break;
            if(hlp[0][j] != need)
            {
                for(size_t i = 0; i < n; ++i)
                {
                    hlp[i][j] = need;
                    swap(v[i][j], v[n2-1-i][j]);
                }
                moves.push_back(Move('-', j+1));
            }
        }
        if(bad)
        {
            fprintf(fout, "-1\n");
            continue;
        }
        for(size_t up = 0; up < n && !bad; ++up)
            for(size_t left = 0; left < n; ++left)
            {
                counter = 0;
                right = n2-1-left, down = n2-1-up;
                while(v[up][left] != v[0][0])
                {
                    moves.push_back(Move('-', left+1));
                    moves.push_back(Move('+', down+1));
                    moves.push_back(Move('-', left+1));
                    moves.push_back(Move('+', down+1));
                    tmp = v[up][left];
                    v[up][left] = v[down][right];
                    v[down][right] = v[down][left];
                    v[down][left] = tmp;
                    ++counter;
                    if(counter > 3)
                    {
                        bad = true;
                        break;
                    }
                }
                if(bad)
                    break;
                counter = 0;
                while(v[down][left] != v[n2-1][0] || v[up][right] != v[0][n2-1])
                {
                    moves.push_back(Move('-', right+1));
                    moves.push_back(Move('+', down+1));
                    moves.push_back(Move('-', right+1));
                    moves.push_back(Move('+', down+1));
                    tmp = v[up][right];
                    v[up][right] = v[down][left];
                    v[down][left] = v[down][right];
                    v[down][right] = tmp;
                    ++counter;
                    if(counter > 3)
                    {
                        bad = true;
                        break;
                    }
                }
                if(bad)
                    break;
            }
        if(bad)
        {
            fprintf(fout, "-1\n");
            continue;
        }
        fprintf(fout, "%u\n", moves.size());
        for(size_t i = 0; i < moves.size(); ++i)
            fprintf(fout, "%c%u\n", moves[i].dir, moves[i].num);
    }
    fclose(fin);
    fclose(fout);
    return 0;
}
