/* GCC */

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <map>
#include <cmath>
#include <utility>
using namespace std;

int p[4];

int trans[4] = {3, 2, 1, 0};

vector <int> moves;

void read(istream& fin, vector<vector<int> >& v, int& n)
{
    fin >> n;

    for (int i = 0; i < 2*n; ++i)
    {
        v.push_back(vector<int>());
        for (int j = 0; j < 2*n; ++j)
        {
            int t;
            fin >> t;
            v[i].push_back(t);
        }
    }
}

void show(const vector <vector <int> >& v)
{
    for (int i = 0; i < v.size(); ++i)
    {
        for (int j = 0; j < v[i].size(); ++j)
        {
            cout << v[i][j] << ' ';
        }
        cout << endl;
    }
}

void mirror_row(vector <vector <int> >& v, int row)
{
    for (int i = 0; i <= (v.size()-1)/2; ++i)
    {
        swap(v[i][row-1], v[v.size() -1-i][row-1]);
    }
}

void mirror_col(vector <vector <int> >& v, int col)
{
    for (int i = 0; i <= (v.size()-1)/2; ++i)
    {
        swap(v[col-1][i], v[col-1][v.size() -1-i]);
    }
}

void do_move(vector <vector <int> >& v, int mv)
{
    moves.push_back(mv);
    if (mv > 0)
        mirror_col(v, mv);
    else
        mirror_row(v, -mv);
}

bool analyze(vector <vector <int> >& v)
{
    map<int, int> k;

    for (int i = 0; i < v.size(); ++i)
    {
        for (int j = 0; j < v[i].size(); ++j)
        {
            if (k.find(v[i][j]) == k.end())
                k[v[i][j]] = 1;
            else
                k[v[i][j]]++;
        }

    }
    if (k.size() > 4)
        return false;

    int n = pow(v.size()/2, 2);
    int j = 0;
    for (map<int, int>::iterator i = k.begin(); i != k.end(); ++i)
    {
        if ((*i).second % n != 0)
            return false;
        for (int k = 0; k < (*i).second / n; ++k, ++j)
            p[j] = (*i).first;
    }

    return true;
        //cout << (*i).first << " = " << (*i).second << endl;
}

void compare(int* n[], int& k, int& z)
{
    k = 0;
    z = -1;
    for (int i = 0; i < 4; ++i)
        if (*(n[i]) == p[i])
        {
            k++;
            z = i;
        }
}

void tr(vector <vector <int> >& v, int a, int b)
{
    do_move(v, a);
    do_move(v, b);
    do_move(v, a);
    do_move(v, b);
}

bool solve(vector <vector <int> >& v, int x, int y)
{
    pair<int, int> c[4];
    int* n[4];
    n[0] = &v[x][y];
    c[0] = make_pair(x, y);
    n[1] = &v[x][v.size() -1 - y];
    c[1] = make_pair(x, v.size() -1 - y);
    n[2] = &v[v.size() - 1 - x][y];
    c[2] = make_pair(v.size() - 1 - x, y);
    n[3] = &v[v.size() - 1 - x][v.size() - 1 - y];
    c[3] = make_pair(v.size() - 1 - x, v.size() - 1 - y);

    int z, k;
    compare(n, k, z);
    if ( k == 4)
        return true;
    //cout << k << " " << z << endl;
    /*if (k == 2)
        return false;*/
    if (k == 0)
        tr(v, x+1, -(1+y));
    compare(n, k, z);
    //cout << k << " " << z << endl;
    tr(v, c[trans[z]].first+1, -(c[trans[z]].second+1));
    compare(n, k, z);
    if (k == 4)
        return true;
    else
        tr(v, c[trans[z]].first+1, -(c[trans[z]].second+1));
    compare(n, k, z);
    if (k == 4)
        return true;
    else
        return false;

}


int main()
{
    ifstream fin("square.in");
    fin.sync_with_stdio(false);

    ofstream fout("square.out");
    fout.sync_with_stdio(false);

    int tests;
    fin >> tests;
    for (int kt = 0; kt < tests; ++kt)
    {
        int n;
        vector<vector<int> > v;
        read(fin, v, n);
        if (n == 1)
        {
            fout << "0\n";
            continue;
        }
        if (!analyze(v))
        {
            fout << "-1\n";
            continue;
        }
        moves.clear();
        bool failed = false;
        for (int i = 0; i < 2; ++i)
            for (int j = 0; j < 2; ++j)
                if (!solve(v, i, j))
                {
                    failed = true;
                    break;
                }
        if (failed)
        {
            fout << "-1\n";
        }
        else
        {
            fout << moves.size() << endl;
            for (int i = 0; i < moves.size(); ++i)
                fout << showpos <<moves[i] << endl;
            fout << noshowpos;
        }
    }
    fout.close();
    fin.close();
/*
    show(v);



    for (int i = 0; i < 2; ++i)
        for (int j = 0; j < 2; ++j)
            if (!solve(v, i, j))
                cout << "failed\n";
    //cout << p[0][0] << " " << p[0][1] << " " << p[1][0] << " "<<  p[1][1] << endl;

    for (int i = 0; i < moves.size(); ++i)
        cout << moves[i] <<  " ";
    cout << endl;

    cout << "Hello world!" << endl;
    show(v);*/

    return 0;
}
